dojo.provide("epages.event.interval");

epages.event.interval = {
	// summary: cross browser function to set intervals
	// description: cross browser function to set intervals without using the built in function "setInterval" (which can cause serious timing problems).
	// set: set an interval (e.g.: var myinterval = epages.event.interval.set(function(){alert("test")}, 1000);
	// clear: clear the given interval (e.g.: epages.event.interval.clear(myinterval));
	
	_container: [],
	_setIntervalSecure: function(/* string */intervalId, /* function */task, /* uinteger */delay) {
		if(this._container[intervalId] != null) {
			setTimeout(dojo.hitch(this, function(){this._setIntervalSecure(intervalId, task, delay)}), delay);
			task();
		}
	},
	
	set: function(/* function */task, /* uinteger */delay) {
		var intervalId = this._container.length;
		this._container.push(intervalId);
		setTimeout(dojo.hitch(this, function(){this._setIntervalSecure(intervalId, task, delay)}), delay);
		return intervalId;
	},
	
	clear: function(/* string */intervalId) {
		this._container[intervalId] = null;
	}
	
};